##parameters=level=None, base=None, show_docs=None, base_path='/'

# XXX to fix : selected, create_url

if level is None:
   return

if show_docs is None:
   show_docs = 0
else:
   try:
      show_docs=int(show_docs)
   except:
      show_docs = 0

try:
   level = int(level)
except:
   return

REQUEST = context.REQUEST

utool = context.portal_url
mtool = context.portal_membership
portal_url = utool(relative=1) 
if portal_url != '/':
    portal_url = '/' + portal_url

current_obj = REQUEST.get('context_obj', context)
current_path = '/' + utool.getRelativeUrl(current_obj)

if not base_path.startswith('/'):
    base_path = '/' + base_path

base_url = portal_url
if base_path != '/':
    base_url += base_path

try:
    base_obj = context.restrictedTraverse(base_url)
except KeyError:
    return

if not current_path.startswith(base_path):
   if level > 0:
       return 
   else:
       level_obj = base_obj
else:
   split_current_path = current_path.split('/')
   if not getattr(current_obj.aq_explicit, 'isPrincipiaFolderish', 0):
       split_current_path = split_current_path[0:len(split_current_path)-1]
   split_base_path = base_path.split('/')
   split_relative_path = split_current_path[0:len(split_base_path)+level-1]

   if split_relative_path == ['']:
       level_obj = utool
   else:
       relative_path = '/'.join(split_relative_path) 
       level_obj = context.restrictedTraverse(portal_url + relative_path)

   if len(split_relative_path) <= level:
       return 

dict = {}
obj_info = []

# XXX FIXME: create_url
create_url = ''
folder_title = level_obj.Title()

for obj in level_obj.contentValues():
       folderish = 0
       if getattr(obj.aq_explicit, 'isPrincipiaFolderish', 0):
           folderish = 1
       if not folderish and not show_docs: 
           continue

       info = {}
       info['id'] =  obj.getId()
       info['title'] = obj.title_or_id()
       rurl = utool.getRelativeUrl(obj)
       url =  portal_url + rurl
       info['url'] = obj.absolute_url()

       # XXX FIXME: selected
       info['selected'] = 0
                
       info['icon'] = obj.getIcon()
       info['folderish'] = folderish
       obj_info.append(info) 

return { 'menuentries': obj_info,
         'create_url': create_url,
         'folder_title': folder_title }

